unit Unit3;

interface

uses
 Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Math;

type
  TForm3 = class(TForm)
    Label1: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Text2: TMemo;
    Text3: TMemo;
    Button4: TButton;
    Text7: TMemo;
    Text9: TMemo;
    Text4: TMemo;
    Text5: TMemo;
    Text6: TMemo;
    Text8: TMemo;
    Text10: TMemo;
    Text11: TMemo;
    Text12: TMemo;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit8: TLabeledEdit;
    Text1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Label12: TLabel;
    LabeledEdit7: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
 
  private
    { Private declarations }
  public
    { Public declarations }
    	k1, k2, k3, x11, x12, x13, x21, x22, x23, x31, x32, x33, wg, t, y10, y20,
	y30, y40, y50, y60, y1, y2, y3, y4, y5, y6, f1, f2, p, xk, e, x0, xs, xs0,
	dtr, ts, cj, uz, dpr, pk, h, va, alfa, alpe, muj, nuj, roj, lamj, nu, k,
	t0, ss, tk, dt, pr, q, gb, dh1, wb, hr: Single;
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}


procedure TForm3.Button1Click(Sender: TObject);

label
	L1, L2, L3;
var
	deltat, uhr, kb,  ss: real;
  db, prj, re, fi, fgt, uot, up, re1, lamtr, kk, wj, tau0, roj, rog, sigm :real;
	hi, r, upe, uzpe, d: real;
	nt, n6: integer;
  i, n: integer;
  e, x0, x11, x12, x13,	x21, x22, x23, x31, x32, x33,	y20, y30, y40, y60,	dpr, pk, va :real;

  begin


	n := Round(StrToFloat(LabeledEdit1.Text));
	y10 := StrToFloat(LabeledEdit2.Text);
	y50 := StrToFloat(LabeledEdit3.Text);
	wg := StrToFloat(LabeledEdit4.Text);
	t := StrToFloat(LabeledEdit5.Text);
	dtr := StrToFloat(LabeledEdit6.Text);
	d := StrToFloat(LabeledEdit7.Text);
	ts := StrToFloat(LabeledEdit8.Text);

	h := 10;
	e := 0.01;
	x0 := 0.5;
	xs := x0;
	xs0 := 0;
	x11 := 0.59; x12 := 93.4; x13 := 273.6;
	x21 := 213.45; x22 := 2717.07; x23 := 1223.07;
	x31 := 673.496; x32 := 2003.328; x33 := 566.402;
	y20 := 0; y30 := 0; y40 := 0; y60 := 0;
	dpr := -0.25;
	pk := 6;
	va := 0.784*Power(d,  2)*h;


	for i:=1 to n do
   begin
		muj := 0.000235-Power(10, -8)*t;
		cj := 1900+t/100;
		lamj := 8*Power(10, -8)*Power(t,  2)-0.0001*t+0.1531;
		roj := 0.0003*Power(t,  2)-0.672*t+1087.4;
		nuj := muj/roj;
		uz := 2.2*Power((nuj*9.81*wg),  0.25);
		k1 := 1/(x11*exp(x12/t/8.314)+x13/wg);
		k2 := 1/(x21*exp(x22/t/8.314)+x23/wg);
		k3 := 1/(x31*exp(x32/t/8.314)+x33/wg);
		pr := 0.785*d*d*wg;
		k := 1.03/0.73;
		t0 := 293;
		pk := pk+dpr;
		ss := pk;
		tk := t0*Power(ss, ((k-1)/k));
		dt := tk-353;
		q := pr*1.29*1030*dt;
		gb := q/4190/30;

	L1:
    f1 := xs-xs0-ts*k3*(y10-y10*exp(-k1*ts)-xs+y20+y30)*(y50-xs-y50*exp(-k2*ts)+y40);
		f2 := 1+ts*k3*(y10-y10*exp(-k1*ts)+y50-y50*exp(-k2*ts)-2*xs+y20+y30+y40);
		p := f1/f2;
		xk := xs-p;
		if Abs(p)<e then goto L2
    Else
		xs := xk;
		goto L2;

	L2:
    y1 := y10*exp(-k1*ts);
		y2 := y10-y1-xk+y20+y30;
		y5 := xk+(y50-y30)*exp(-k2*ts);
		y4 := y50-y5+y40;
		y6 := y10-y1-y5+y50+xk;

		dh1 := (Abs(y1-y10)*24.34+Abs(y2-y20)*8430+Abs(y3-y30)*826+Abs(y4-y40)*789.2+Abs(y5-y50)*425.2+Abs(y6-y60)*242.2)*1000;
		hr := dh1*va/3600;

		wb := hr/cj/dt;

  	Text1.Text := Text1.Text+''+IntToStr(i)+'   '+FloatToStr(y1)+#13#10;
		Text2.Text := Text2.Text+''+IntToStr(i)+'   '+FloatToStr(y2)+#13#10;
		Text3.Text := Text3.Text+''+IntToStr(i)+'   '+FloatToStr(xk)+#13#10;
		Text4.Text := Text4.Text+''+IntToStr(i)+'   '+FloatToStr(y4)+#13#10;
		Text5.Text := Text5.Text+''+IntToStr(i)+'   '+FloatToStr(y5)+#13#10;
		Text6.Text := Text6.Text+''+IntToStr(i)+'   '+FloatToStr(y6)+#13#10;

		xs := xk;
		y10 := y1; y50 := y5; y20 := y2; y30 := xk;
		y40 := y4;
		xs0 := xk;

		kb := wg/Power((nuj*9.81), 0.333);
		prj := cj*muj/lamj;
		if kb<=18 then begin
			nu := (Power(kb,  0.25)*Power(prj,  0.333))*0.146;
			goto L3;
		end;

		if kb>18 then
    nu := 0.3*Power(prj,  0.333);
	  L3: alfa := (nu*lamj*Power(9.81, 0.333))/Power((nuj*nuj),  0.333);
		alpe := prj*lamj*uz/(4.4+15*Power(prj,  0.5))/nuj;

		Text7.Text := Text7.Text+''+IntToStr(i)+'   '+FloatToStr(gb)+#13#10;
		Text9.Text := Text9.Text+''+IntToStr(i)+'   '+FloatToStr(wb)+#13#10;
		Text8.Text := Text8.Text+''+IntToStr(i)+'   '+FloatToStr(alfa)+#13#10;
		Text10.Text := Text10.Text+''+IntToStr(i)+'   '+FloatToStr(alpe)+#13#10;
		Text11.Text := Text11.Text+''+IntToStr(i)+'   '+FloatToStr(t)+#13#10;
		Text12.Text := Text12.Text+''+IntToStr(i)+'   '+FloatToStr(pk)+#13#10;
		t := t+dtr;
	end;

end;


procedure TForm3.Button4Click(Sender: TObject);
begin
  Text1.Text := '';
	Text2.Text := '';
	Text3.Text := '';
	Text4.Text := '';
	Text5.Text := '';
	Text6.Text := '';
	Text7.Text := '';
	Text9.Text := '';
	Text8.Text := '';
	Text10.Text := '';
	Text11.Text := '';
	Text12.Text := '';
  LabeledEdit1.Text:= '';
	LabeledEdit2.Text:= '';
	LabeledEdit3.Text:= '';
	LabeledEdit4.Text := '';
	LabeledEdit5.Text := '';
	LabeledEdit6.Text := '';
	LabeledEdit7.Text := '';
	LabeledEdit8.Text := '';
end;


procedure TForm3.Button2Click(Sender: TObject);
begin
Form3.Close;
end;






end.
